{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
{-# LANGUAGE OverloadedStrings #-}

-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.

-- | Contains the different functions to run the operation getRefunds
module StripeAPI.Operations.GetRefunds where

import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Generics
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > GET /v1/refunds
--
-- \<p>Returns a list of all refunds you’ve previously created. The refunds are returned in sorted order, with the most recent refunds appearing first. For convenience, the 10 most recent refunds are always available by default on the charge object.\<\/p>
getRefunds ::
  forall m s.
  (StripeAPI.Common.MonadHTTP m, StripeAPI.Common.SecurityScheme s) =>
  -- | The configuration to use in the request
  StripeAPI.Common.Configuration s ->
  -- | charge: Only return refunds for the charge specified by this charge ID.
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  -- | created
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  -- | ending_before: A cursor for use in pagination. \`ending_before\` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with \`obj_bar\`, your subsequent call can include \`ending_before=obj_bar\` in order to fetch the previous page of the list.
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  -- | expand: Specifies which fields in the response should be expanded.
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  -- | limit: A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
  GHC.Maybe.Maybe GHC.Integer.Type.Integer ->
  -- | payment_intent: Only return refunds for the PaymentIntent specified by this ID. | Constraints: Maximum length of 5000
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  -- | starting_after: A cursor for use in pagination. \`starting_after\` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with \`obj_foo\`, your subsequent call can include \`starting_after=obj_foo\` in order to fetch the next page of the list.
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe GetRefundsRequestBody ->
  -- | Monad containing the result of the operation
  m (Data.Either.Either Network.HTTP.Client.Types.HttpException (Network.HTTP.Client.Types.Response GetRefundsResponse))
getRefunds
  config
  charge
  created
  endingBefore
  expand
  limit
  paymentIntent
  startingAfter
  body =
    GHC.Base.fmap
      ( GHC.Base.fmap
          ( \response_0 ->
              GHC.Base.fmap
                ( Data.Either.either GetRefundsResponseError GHC.Base.id
                    GHC.Base.. ( \response body ->
                                   if  | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                         GetRefundsResponse200
                                           Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                                Data.Either.Either GHC.Base.String
                                                                  GetRefundsResponseBody200
                                                            )
                                       | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                         GetRefundsResponseDefault
                                           Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                                Data.Either.Either GHC.Base.String
                                                                  Error
                                                            )
                                       | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                               )
                      response_0
                )
                response_0
          )
      )
      ( StripeAPI.Common.doBodyCallWithConfiguration
          config
          (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET")
          (Data.Text.pack "/v1/refunds")
          ( ( Data.Text.pack "charge",
              StripeAPI.Common.stringifyModel Data.Functor.<$> charge
            )
              : ( ( Data.Text.pack "created",
                    StripeAPI.Common.stringifyModel Data.Functor.<$> created
                  )
                    : ( ( Data.Text.pack "ending_before",
                          StripeAPI.Common.stringifyModel Data.Functor.<$> endingBefore
                        )
                          : ( ( Data.Text.pack "expand",
                                StripeAPI.Common.stringifyModel Data.Functor.<$> expand
                              )
                                : ( ( Data.Text.pack "limit",
                                      StripeAPI.Common.stringifyModel Data.Functor.<$> limit
                                    )
                                      : ( ( Data.Text.pack "payment_intent",
                                            StripeAPI.Common.stringifyModel Data.Functor.<$> paymentIntent
                                          )
                                            : ( ( Data.Text.pack "starting_after",
                                                  StripeAPI.Common.stringifyModel Data.Functor.<$> startingAfter
                                                )
                                                  : []
                                              )
                                        )
                                  )
                            )
                      )
                )
          )
          body
          StripeAPI.Common.RequestBodyEncodingFormData
      )

-- | > GET /v1/refunds
--
-- The same as 'getRefunds' but returns the raw 'Data.ByteString.Char8.ByteString'
getRefundsRaw ::
  forall m s.
  ( StripeAPI.Common.MonadHTTP m,
    StripeAPI.Common.SecurityScheme s
  ) =>
  StripeAPI.Common.Configuration s ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe GHC.Integer.Type.Integer ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe GetRefundsRequestBody ->
  m
    ( Data.Either.Either Network.HTTP.Client.Types.HttpException
        (Network.HTTP.Client.Types.Response Data.ByteString.Internal.ByteString)
    )
getRefundsRaw
  config
  charge
  created
  endingBefore
  expand
  limit
  paymentIntent
  startingAfter
  body =
    GHC.Base.id
      ( StripeAPI.Common.doBodyCallWithConfiguration
          config
          (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET")
          (Data.Text.pack "/v1/refunds")
          ( ( Data.Text.pack "charge",
              StripeAPI.Common.stringifyModel Data.Functor.<$> charge
            )
              : ( ( Data.Text.pack "created",
                    StripeAPI.Common.stringifyModel Data.Functor.<$> created
                  )
                    : ( ( Data.Text.pack "ending_before",
                          StripeAPI.Common.stringifyModel Data.Functor.<$> endingBefore
                        )
                          : ( ( Data.Text.pack "expand",
                                StripeAPI.Common.stringifyModel Data.Functor.<$> expand
                              )
                                : ( ( Data.Text.pack "limit",
                                      StripeAPI.Common.stringifyModel Data.Functor.<$> limit
                                    )
                                      : ( ( Data.Text.pack "payment_intent",
                                            StripeAPI.Common.stringifyModel Data.Functor.<$> paymentIntent
                                          )
                                            : ( ( Data.Text.pack "starting_after",
                                                  StripeAPI.Common.stringifyModel Data.Functor.<$> startingAfter
                                                )
                                                  : []
                                              )
                                        )
                                  )
                            )
                      )
                )
          )
          body
          StripeAPI.Common.RequestBodyEncodingFormData
      )

-- | > GET /v1/refunds
--
-- Monadic version of 'getRefunds' (use with 'StripeAPI.Common.runWithConfiguration')
getRefundsM ::
  forall m s.
  ( StripeAPI.Common.MonadHTTP m,
    StripeAPI.Common.SecurityScheme s
  ) =>
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe GHC.Integer.Type.Integer ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe GetRefundsRequestBody ->
  Control.Monad.Trans.Reader.ReaderT (StripeAPI.Common.Configuration s)
    m
    ( Data.Either.Either Network.HTTP.Client.Types.HttpException
        (Network.HTTP.Client.Types.Response GetRefundsResponse)
    )
getRefundsM
  charge
  created
  endingBefore
  expand
  limit
  paymentIntent
  startingAfter
  body =
    GHC.Base.fmap
      ( GHC.Base.fmap
          ( \response_2 ->
              GHC.Base.fmap
                ( Data.Either.either GetRefundsResponseError GHC.Base.id
                    GHC.Base.. ( \response body ->
                                   if  | (\status_3 -> Network.HTTP.Types.Status.statusCode status_3 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                         GetRefundsResponse200
                                           Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                                Data.Either.Either GHC.Base.String
                                                                  GetRefundsResponseBody200
                                                            )
                                       | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                         GetRefundsResponseDefault
                                           Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                                Data.Either.Either GHC.Base.String
                                                                  Error
                                                            )
                                       | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                               )
                      response_2
                )
                response_2
          )
      )
      ( StripeAPI.Common.doBodyCallWithConfigurationM
          (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET")
          (Data.Text.pack "/v1/refunds")
          ( ( Data.Text.pack "charge",
              StripeAPI.Common.stringifyModel Data.Functor.<$> charge
            )
              : ( ( Data.Text.pack "created",
                    StripeAPI.Common.stringifyModel Data.Functor.<$> created
                  )
                    : ( ( Data.Text.pack "ending_before",
                          StripeAPI.Common.stringifyModel Data.Functor.<$> endingBefore
                        )
                          : ( ( Data.Text.pack "expand",
                                StripeAPI.Common.stringifyModel Data.Functor.<$> expand
                              )
                                : ( ( Data.Text.pack "limit",
                                      StripeAPI.Common.stringifyModel Data.Functor.<$> limit
                                    )
                                      : ( ( Data.Text.pack "payment_intent",
                                            StripeAPI.Common.stringifyModel Data.Functor.<$> paymentIntent
                                          )
                                            : ( ( Data.Text.pack "starting_after",
                                                  StripeAPI.Common.stringifyModel Data.Functor.<$> startingAfter
                                                )
                                                  : []
                                              )
                                        )
                                  )
                            )
                      )
                )
          )
          body
          StripeAPI.Common.RequestBodyEncodingFormData
      )

-- | > GET /v1/refunds
--
-- Monadic version of 'getRefundsRaw' (use with 'StripeAPI.Common.runWithConfiguration')
getRefundsRawM ::
  forall m s.
  ( StripeAPI.Common.MonadHTTP m,
    StripeAPI.Common.SecurityScheme s
  ) =>
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe GHC.Integer.Type.Integer ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe Data.Text.Internal.Text ->
  GHC.Maybe.Maybe GetRefundsRequestBody ->
  Control.Monad.Trans.Reader.ReaderT (StripeAPI.Common.Configuration s)
    m
    ( Data.Either.Either Network.HTTP.Client.Types.HttpException
        (Network.HTTP.Client.Types.Response Data.ByteString.Internal.ByteString)
    )
getRefundsRawM
  charge
  created
  endingBefore
  expand
  limit
  paymentIntent
  startingAfter
  body =
    GHC.Base.id
      ( StripeAPI.Common.doBodyCallWithConfigurationM
          (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET")
          (Data.Text.pack "/v1/refunds")
          ( ( Data.Text.pack "charge",
              StripeAPI.Common.stringifyModel Data.Functor.<$> charge
            )
              : ( ( Data.Text.pack "created",
                    StripeAPI.Common.stringifyModel Data.Functor.<$> created
                  )
                    : ( ( Data.Text.pack "ending_before",
                          StripeAPI.Common.stringifyModel Data.Functor.<$> endingBefore
                        )
                          : ( ( Data.Text.pack "expand",
                                StripeAPI.Common.stringifyModel Data.Functor.<$> expand
                              )
                                : ( ( Data.Text.pack "limit",
                                      StripeAPI.Common.stringifyModel Data.Functor.<$> limit
                                    )
                                      : ( ( Data.Text.pack "payment_intent",
                                            StripeAPI.Common.stringifyModel Data.Functor.<$> paymentIntent
                                          )
                                            : ( ( Data.Text.pack "starting_after",
                                                  StripeAPI.Common.stringifyModel Data.Functor.<$> startingAfter
                                                )
                                                  : []
                                              )
                                        )
                                  )
                            )
                      )
                )
          )
          body
          StripeAPI.Common.RequestBodyEncodingFormData
      )

-- | Defines the data type for the schema getRefundsRequestBody
data GetRefundsRequestBody
  = GetRefundsRequestBody
      {
      }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.ToJSON GetRefundsRequestBody where
  toJSON obj = Data.Aeson.object []
  toEncoding obj = Data.Aeson.pairs ((Data.Aeson..=) "string" ("string" :: GHC.Base.String))

instance Data.Aeson.Types.FromJSON.FromJSON GetRefundsRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetRefundsRequestBody" (\obj -> GHC.Base.pure GetRefundsRequestBody)

-- | Represents a response of the operation 'getRefunds'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'GetRefundsResponseError' is used.
data GetRefundsResponse
  = -- | Means either no matching case available or a parse error
    GetRefundsResponseError GHC.Base.String
  | -- | Successful response.
    GetRefundsResponse200 GetRefundsResponseBody200
  | -- | Error response.
    GetRefundsResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)

-- | Defines the data type for the schema GetRefundsResponseBody200
data GetRefundsResponseBody200
  = GetRefundsResponseBody200
      { -- | data
        getRefundsResponseBody200Data :: ([] Refund),
        -- | has_more: True if this list has another page of items after this one that can be fetched.
        getRefundsResponseBody200HasMore :: GHC.Types.Bool,
        -- | object: String representing the object\'s type. Objects of the same type share the same value. Always has the value \`list\`.
        getRefundsResponseBody200Object :: GetRefundsResponseBody200Object',
        -- | url: The URL where this list can be accessed.
        --
        -- Constraints:
        --
        -- * Maximum length of 5000
        -- * Must match pattern \'^\/v1\/refunds\'
        getRefundsResponseBody200Url :: Data.Text.Internal.Text
      }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.ToJSON GetRefundsResponseBody200 where
  toJSON obj = Data.Aeson.object ((Data.Aeson..=) "data" (getRefundsResponseBody200Data obj) : (Data.Aeson..=) "has_more" (getRefundsResponseBody200HasMore obj) : (Data.Aeson..=) "object" (getRefundsResponseBody200Object obj) : (Data.Aeson..=) "url" (getRefundsResponseBody200Url obj) : [])
  toEncoding obj = Data.Aeson.pairs ((Data.Aeson..=) "data" (getRefundsResponseBody200Data obj) GHC.Base.<> ((Data.Aeson..=) "has_more" (getRefundsResponseBody200HasMore obj) GHC.Base.<> ((Data.Aeson..=) "object" (getRefundsResponseBody200Object obj) GHC.Base.<> (Data.Aeson..=) "url" (getRefundsResponseBody200Url obj))))

instance Data.Aeson.Types.FromJSON.FromJSON GetRefundsResponseBody200 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetRefundsResponseBody200" (\obj -> (((GHC.Base.pure GetRefundsResponseBody200 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "has_more")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "object")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Defines the enum schema GetRefundsResponseBody200Object\'
--
-- String representing the object\'s type. Objects of the same type share the same value. Always has the value \`list\`.
data GetRefundsResponseBody200Object'
  = GetRefundsResponseBody200Object'EnumOther Data.Aeson.Types.Internal.Value
  | GetRefundsResponseBody200Object'EnumTyped Data.Text.Internal.Text
  | GetRefundsResponseBody200Object'EnumStringList
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.ToJSON GetRefundsResponseBody200Object' where
  toJSON (GetRefundsResponseBody200Object'EnumOther patternName) = Data.Aeson.Types.ToJSON.toJSON patternName
  toJSON (GetRefundsResponseBody200Object'EnumTyped patternName) = Data.Aeson.Types.ToJSON.toJSON patternName
  toJSON (GetRefundsResponseBody200Object'EnumStringList) = Data.Aeson.Types.Internal.String GHC.Base.$ Data.Text.pack "list"

instance Data.Aeson.FromJSON GetRefundsResponseBody200Object' where
  parseJSON val =
    GHC.Base.pure
      ( if val GHC.Classes.== (Data.Aeson.Types.Internal.String GHC.Base.$ Data.Text.pack "list")
          then GetRefundsResponseBody200Object'EnumStringList
          else GetRefundsResponseBody200Object'EnumOther val
      )
